SecBlockWithHint< T, S, A > Class Template Reference

Stack-based SecBlock that grows into the heap. More...

`#include <secblock.h>`

Inheritance diagram for SecBlockWithHint< T, S, A >:

## Public Member Functions

| SecBlockWithHint (size_t size)
| construct a SecBlockWithHint with a count of elements
Public Member Functions inherited from SecBlock< T, A >
| SecBlock (size_type size=0)
| Construct a SecBlock with space for size elements.
| SecBlock (const SecBlock< T, A > &t)
| Copy construct a SecBlock from another SecBlock.
| SecBlock (const T *ptr, size_type len)
| Construct a SecBlock from an array of elements.
| operator const void * () const
| Cast operator.
| operator void * ()
| Cast operator.
| operator const T * () const
| Cast operator.
| operator T* ()
| Cast operator.
iterator | begin ()
| Provides an iterator pointing to the first element in the memory block.
const_iterator | begin () const
| Provides a constant iterator pointing to the first element in the memory block.
iterator | end ()
| Provides an iterator pointing beyond the last element in the memory block.
const_iterator | end () const
| Provides a constant iterator pointing beyond the last element in the memory block.
A::pointer | data ()
| Provides a pointer to the first element in the memory block.
A::const_pointer | data () const
| Provides a pointer to the first element in the memory block.
size_type | size () const
| Provides the count of elements in the SecBlock.
bool | empty () const
| Determines if the SecBlock is empty.
byte * | BytePtr ()
| Provides a byte pointer to the first element in the memory block.
const byte * | BytePtr () const
| Return a byte pointer to the first element in the memory block.
size_type | SizeInBytes () const
| Provides the number of bytes in the SecBlock.
void | Assign (const T *ptr, size_type len)
| Set contents and size from an array.
void | Assign (size_type count, T value)
| Set contents from a value.
void | Assign (const SecBlock< T, A > &t)
| Copy contents from another SecBlock.
void | Append (const T *ptr, size_type len)
| Append contents from an array.
void | Append (const SecBlock< T, A > &t)
| Append contents from another SecBlock.
void | Append (size_type count, T value)
| Append contents from a value.
void | SetMark (size_t count)
| Sets the number of elements to zeroize.
SecBlock< T, A > & | operator= (const SecBlock< T, A > &t)
| Assign contents from another SecBlock.
SecBlock< T, A > & | operator+= (const SecBlock< T, A > &t)
| Append contents from another SecBlock.
SecBlock< T, A > | operator+ (const SecBlock< T, A > &t)
| Construct a SecBlock from this and another SecBlock.
bool | operator== (const SecBlock< T, A > &t) const
| Bitwise compare two SecBlocks.
bool | operator!= (const SecBlock< T, A > &t) const
| Bitwise compare two SecBlocks.
void | New (size_type newSize)
| Change size without preserving contents.
void | CleanNew (size_type newSize)
| Change size without preserving contents.
void | Grow (size_type newSize)
| Change size and preserve contents.
void | CleanGrow (size_type newSize)
| Change size and preserve contents.
void | resize (size_type newSize)
| Change size and preserve contents.
void | swap (SecBlock< T, A > &b)
| Swap contents with another SecBlock.

## Additional Inherited Members

Public Types inherited from SecBlock< T, A >
typedef A::value_type | value_type
typedef A::pointer | iterator
typedef A::const_pointer | const_iterator
typedef A::size_type | size_type
Static Public Attributes inherited from SecBlock< T, A >
static const size_type | ELEMS_MAX = ...
| Returns the maximum number of elements the block can hold.

## Detailed Description

template<class T, unsigned int S, class A = FixedSizeAllocatorWithCleanup<T, S, AllocatorWithCleanup<T> >>
class SecBlockWithHint< T, S, A >

Stack-based SecBlock that grows into the heap.

Template Parameters

  T | class or type
  S | fixed-size of the stack-based memory block, in elements
  A | AllocatorBase derived class for allocation and cleanup

Definition at line 1267 of file secblock.h.

## Constructor & Destructor Documentation

## SecBlockWithHint()

template<class T, unsigned int S, class A = FixedSizeAllocatorWithCleanup<T, S, AllocatorWithCleanup<T> >>

SecBlockWithHint< T, S, A >::SecBlockWithHint | ( | size_t | size | ) |

inline explicit

construct a SecBlockWithHint with a count of elements

Definition at line 1271 of file secblock.h.

The documentation for this class was generated from the following file:

- secblock.h